;    
;: ZEvS
;  2103
;:  
;   4 

.include "m8def.inc"
.cseg
.org 0

;  
.def	ah=r16			; 
.def	al=r17
.def	bh=r18
.def	bl=r19

.def	count_l=r20		; 
.def	count_h=r21

.def	tooth=r23		; 
.def	  uoz=r22		;

.def	mode=r24		;

;	  
	rjmp	Reset
	rjmp	Front_Signal
	nop		;External	1
	nop		;Timer 2 Compare
	nop		;Timer 2 Overflow
	nop		;Timer 1 Caputure
	rjmp	Timer1_Comp		;Timer 1 Compare A
	nop		;Timer 1 Compare B
	rjmp	Timer_OVF1
	nop		;Timer 0 Overflow
	nop		;STC
	nop		;RXC
	nop		;UDRE
	nop		;TXC
	rjmp	ADC_Complete
	nop		;EEprom Ready
	nop		;Analog Comparator
	nop		;TWI
	nop		;SPM Ready

Reset:		;    
	cli
	ldi		ah,high(ramend)
	ldi		al,low(ramend)
	out		SPH,ah
	out		SPL,al			; 

;  /
	ldi		ah,$3
	ldi		al,$0
	out		DDRC,ah			;  C
	out		PORTC,al
	ldi		ah,$F2
	out		DDRD,ah			;  D
	out		PORTD,al
	out		DDRB,al
	out		PORTB,al		;  B

; 
	ldi		al,$8F
	out		ADCSR,al
	ldi		al,$42
	out		ADMUX,al		;   PC2
	ldi		al,$C8
	out		ADCSR,al

; 
	in		al,TIMSK
	ori		al,$4
	out		TIMSK,al
	clr		al
	out		TCCR1A,al
	in		al,GIMSK
	ori		al,$40
	out		GIMSK,al
	in		al,MCUCR
	ori		al,$3
	out		MCUCR,al

; UART
;	ldi		al,$08
;	out		UCSRB,al
;	clr		ah
;	ldi		al,25
;	out		UBRRL,al
;	out		UBRRH,ah

;      
	ldi		al,$FF
	sts		$0061,al
	sts		$0062,al
	sts		$0063,al
	sts		$0064,al
	sei
	rjmp	Begin


;****************   ******************
Front_Signal:			;   
	inc		tooth
reti

Timer1_Comp:			; 
	push	mode
	sbi		PORTC,0
	clr		mode
	out		TCCR1B,mode
	pop		mode
reti

Timer_OVF1:				;  1
	nop
	nop
reti

ADC_Complete:			;  
reti

;****************   ******************
Led_Off:				; 
	cbi		PORTD,7
	cbi		PORTD,6
ret

Led_Red:				; 
	sbi		PORTD,7
	cbi		PORTD,6
ret

Led_Yellow:				; 
	sbi		PORTD,7
	sbi		PORTD,6
ret

Led_Green:				; 
	cbi		PORTD,7
	sbi		PORTD,6
ret

Begin:					; 

;1. 
;2.  
;3. 
;4. 1-4
;5.  
;6. 
;7. 2-3
;8.  .1

	rcall	Wait_Start
ACC_0:						; 
	rcall	Sync_Proc
	cbi		PORTC,0
	ldi		al,$0
	sts		$0060,al
	rcall	Freq_Measure
	rcall	Corner_Comp
	rcall	Corner_Set
	ldi		ah,30
ACC_1:						; 
	cp		ah,tooth
	brne	ACC_1
	cbi		PORTC,0
	ldi		al,$1
	sts		$0060,al
	rcall	Freq_Measure
	rcall	Corner_Comp
	rcall	Corner_Set
ACC_2:						; 
	rcall	Sync_Proc
	cbi		PORTC,0
	ldi		al,$2
	sts		$0060,al
	rcall	Freq_Measure
	rcall	Corner_Comp
	rcall	Corner_Set
	ldi		ah,30
ACC_3:						; 
	cp		ah,tooth
	brne	ACC_3
	cbi		PORTC,0
	ldi		al,$3
	sts		$0060,al
	rcall	Freq_Measure
	rcall	Corner_Comp
	rcall	Corner_Set
rjmp	ACC_0

Wait_Start:					;  
	clr		tooth
WS_0:
	cpi		tooth,$3
	brsh	WS_End
	rjmp	WS_0
WS_End:
ret

Sync_Proc:					; 
	clr		count_h
	clr		count_l
SP_0:						; 
	sbic	PIND,2
	rjmp	SP_0

SP_1:						; 
	cli
	clr		al
	out		TCCR1B,al
	out		TCNT1H,al
	out		TCNT1L,al
	sei
SP_1a:
	sbis	PIND,2
	rjmp	SP_1a
	ldi		al,$2		;  125 
	out		TCCR1B,al

SP_2:					; 
	sbic	PIND,2
	rjmp	SP_2

SP_3:					; 
	sbis	PIND,2
	rjmp	SP_3
	clr		al			; 
	out		TCCR1B,al
	cli
	in		al,TCNT1L	;  
	in		ah,TCNT1H	;AX=counter
	sei
	cpi		count_h,$0	;   
	brne	SP_4
	cpi		count_l,$0
	brne	SP_4
	mov		count_l,al	;   
	mov		count_h,ah	;sync=counter
	rjmp	SP_1

SP_4:					;    
	lsl		count_l		;  
	rol		count_h		;sync=sync*2

;     
	cp		al,count_l
	cpc		ah,count_h
	brsh	SP_End		;,   
	mov		count_l,al
	mov		count_h,ah	;sync=counter
	rjmp	SP_1		;,    

SP_End:
	clr		tooth
	nop
ret

Corner_Set:				; 
	push	uoz
	ldi		ah,47
	cpi		tooth,30
	brsh	CS_0
	ldi		ah,17
CS_0:
	cpi		count_h,$21	;  
	brne	CS_0a
	rjmp	Corner_Single
CS_0a:
	mov		al,uoz
	swap	al
	andi	al,$0F		;  ah  
	sub		ah,al
	mov		al,uoz
	andi	al,$0F
	cpi		al,$0
	brne	CS_P
	inc		ah
	inc		ah
CS_1:					;  
	cp		tooth,ah
	brne	CS_1
	sbi		PORTC,0
	rjmp	CS_Exit

CS_P:
	rcall	Counter_Clear	; 
CS_P0:					;  
	cp		ah,tooth
	brne	CS_P0
	ldi		al,$1
	out		TCCR1B,al	;  125 
	inc		ah			;    16   1 
CS_P1:
	cp		ah,tooth
	brne	CS_P1
	clr		al			; 
	out		TCCR1B,al
	cli
	in		bl,TCNT1L	;   BX
	in		bh,TCNT1H
	sei
	lsr		bh			;...   2
	ror		bl
	lsr		bh
	ror		bl
	lsr		bh
	ror		bl
	lsr		bh
	ror		bl
	andi	uoz,$0F
	ldi		ah,$10		;  
	sub		ah,uoz		;ah=16-uoz
	mul		bl,ah
	mov		bl,r0
	mov		al,r1		; BX    uoz (ah)
	mul		bh,ah
	mov		bh,r0		;   BX
	add		bh,al
CS_P2:
	rcall	Counter_Clear	; 
	cli
	in		al,TIMSK	;   
	ori		al,$10
	out		TIMSK,al
	out		OCR1AH,bh	;  
	out		OCR1AL,bl
	sei

	ldi		al,$1
	out		TCCR1B,al	; 	1 

CS_Exit:
	ldi		ah,51
	cpi		tooth,30
	brsh	CS_E0
	ldi		ah,21
CS_E0:
	cp		tooth,ah
	brne	CS_E0
	cli
	in		al,TIMSK	;   
	andi	al,$EF
	out		TIMSK,al
	sei
	pop		uoz
ret

Corner_Single:			;   
	dec		al
	rcall	Counter_Clear	; 
CSS_P0:					;  
	cp		ah,tooth
	brne	CSS_P0
	ldi		al,$1
	out		TCCR1B,al	;  1 
	inc		ah
CSS_P1:
	cp		ah,tooth
	brne	CSS_P1
	clr		al			; 
	out		TCCR1B,al
	cli
	in		bl,TCNT1L	;   BX
	in		bh,TCNT1H
	sei
	ldi		bl,$FF
	sub		bl,uoz
	mul		bh,bl
	mov		bl,r0
	mov		bh,r1
rjmp	CS_P2

Freq_Measure:				;  
	rcall	Counter_Clear
	mov		ah,tooth
	inc		ah
FM_0:
	cp		ah,tooth
	brne	FM_0
	ldi		al,$1
	out		TCCR1B,al
	ldi		al,8
	add		ah,al
FM_1:
	cp		ah,tooth
	brne	FM_1
	clr		al
	out		TCCR1B,al		
	cli
	in		count_l,TCNT1L
	in		count_h,TCNT1H
	sei

FT_End:
	ret

Corner_Comp:				; ,  
	rcall	led_off
	cpi		count_h,$B4
	brsh	CC_P0
	cpi		count_h,$34
	brsh	CC_P1
	cpi		count_h,$22
	brsh	CC_P2
	cpi		count_h,$21
	breq	CC_D0
	cpi		count_h,$1E
	brsh	CC_D1
	cpi		count_h,$10
	brsh	CC_Table0
	cpi		count_h,$0A
	brsh	CC_Table1
	cpi		count_h,$06
	brsh	CC_Table2
	ldi		uoz,$65
	ret

CC_P0:						;  173 / -  0
	clr		uoz
	rjmp	CC_End
CC_P1:						; 173 - 600 /
	ldi		uoz,$B4			; 0 - 6 .
	sub		uoz,count_h
	lsr		uoz
	lsr		uoz
	lsr		uoz
	andi	uoz,$0F
	rjmp	CC_End
CC_P2:						; 600 - 919 /
	ldi		uoz,$34			; 6 - 9 .
	sub		uoz,count_h
	lsr		uoz
	andi	uoz,$0F
	ori		uoz,$10
	rjmp	CC_End
CC_D0:						; ,  919 - 946 /
	rjmp	CC_Single
CC_D1:						; ,  946 - 1041 /
	ldi		uoz,$10			; 6 .
	rjmp	CC_End

CC_Table0:					;  1041 - 1953 
	mov		bh,count_h
	mov		bl,count_l
	ldi		ah,$10
	sub		bh,ah			;bl = (count - 1000h)/64
	lsl		bl
	rol		bh
	lsl		bl
	rol		bh
	clr		bl
	ldi		zl,low(Low_Table*2)
	ldi		zh,high(Low_Table*2)
	add		zl,bh
	adc		zh,bl
	lpm
	mov		uoz,r0
	rjmp	CC_End

CC_Table1:					;  1954 - 3125 
	mov		bh,count_h
	mov		bl,count_l
	ldi		ah,$0A
	sub		bh,ah			;bl = (count - A00h)/16
	swap	bl
	andi	bl,$0F
	swap	bh
	andi	bh,$F0
	or		bl,bh	
	clr		bh
	ldi		zl,low(Medium_Table*2)
	ldi		zh,high(Medium_Table*2)
	add		zl,bl
	adc		zh,bh
	lpm
	mov		uoz,r0
	rjmp	CC_End

CC_Table2:					;  3125 - 5208 
	mov		bh,count_h
	mov		bl,count_l
	ldi		ah,$06
	sub		bh,ah			;bl = (count - 600h)/8
	lsr		bh		
	ror		bl
	lsr		bl
	lsr		bl
	clr		bh
	ldi		zl,low(High_Table*2)
	ldi		zh,high(High_Table*2)
	add		zl,bl
	adc		zh,bh
	lpm
	mov		uoz,r0
	rjmp	CC_End

CC_Single:
	lds		al,$0060
	cpi		al,$0
	breq	CCS_0
	cpi		al,$1
	breq	CCS_1
	cpi		al,$2
	breq	CCS_2
	cpi		al,$3
	breq	CCS_3
	ldi		uoz,$40
	rjmp	CC_End
CCS_0:
	lds		uoz,$0061
	lds		al,$0064
	rcall	CCS_Corr
	sts		$0064,al
	rjmp	CC_End
CCS_1:
	lds		uoz,$0062
	lds		al,$0061
	rcall	CCS_Corr
	sts		$0061,al
	rjmp	CC_End
CCS_2:
	lds		uoz,$0063
	lds		al,$0062
	rcall	CCS_Corr
	sts		$0062,al
	rjmp	CC_End
CCS_3:
	lds		uoz,$0064
	lds		al,$0063
	rcall	CCS_Corr
	sts		$0063,al
	rjmp	CC_End

CCS_Corr:
	cpi		count_l,$9F
	breq	CCSC_End
	cpi		count_l,$9F
	brsh	CCS_UP
	dec		al
	cpi		al,$FF
	brne	CCSC_End
	clr		al
	rjmp	CCSC_End
CCS_UP:
	inc		al
	cpi		al,$0
	brne	CCSC_End
	ser		al
CCSC_End:
ret

CC_End:
ret

Counter_Clear:			; 
	cli
	push	al
	clr		al
	out		TCCR1B,al	;  
	out		TCNT1H,al
	out		TCNT1L,al
	out		OCR1AH,al
	out		OCR1AL,al
	pop		al
	sei
ret

;***********  **********

;   1041 - 1953 /
Low_Table:
.db $26,$25,$25,$24,$23,$22,$22,$21
.db $20,$20,$1F,$1F,$1E,$1D,$1D,$1C
.db $1C,$1C,$1B,$1B,$1B,$1A,$1A,$1A
.db $19,$19,$19,$19,$18,$18,$18,$17
.db $17,$17,$17,$16,$16,$16,$16,$15
.db $15,$15,$15,$15,$14,$14,$14,$14
.db $14,$13,$13,$13,$13,$13,$13,$12

;   1954 - 3125 /
Medium_Table:
.db $57,$56,$56,$56,$55,$55,$55,$55
.db $54,$53,$52,$51,$51,$50,$4F,$4E
.db $4E,$4D,$4C,$4B,$4B,$4A,$49,$49
.db $48,$47,$47,$46,$45,$45,$44,$43
.db $43,$42,$41,$41,$40,$40,$3F,$3F
.db $3E,$3D,$3D,$3C,$3C,$3B,$3B,$3A
.db $3A,$39,$38,$38,$37,$37,$36,$36
.db $35,$35,$35,$34,$34,$33,$33,$32
.db $32,$31,$31,$30,$30,$30,$2F,$2F
.db $2E,$2E,$2E,$2D,$2D,$2C,$2C,$2C
.db $2B,$2B,$2A,$2A,$2A,$29,$29,$29
.db $28,$28,$28,$27,$27,$27,$27,$26

;   3126 - 5208 /
High_Table:
.db $66,$65,$65,$65,$65,$65,$65,$65
.db $65,$65,$65,$64,$64,$64,$64,$64
.db $64,$64,$64,$63,$63,$63,$63,$63
.db $63,$63,$63,$63,$62,$62,$62,$62
.db $62,$62,$62,$62,$62,$61,$61,$61
.db $61,$61,$61,$61,$61,$61,$61,$60
.db $60,$60,$60,$60,$60,$60,$60,$60
.db $60,$60,$60,$5F,$5F,$5F,$5F,$5F
.db $5F,$5F,$5E,$5E,$5E,$5E,$5E,$5E
.db $5E,$5D,$5D,$5D,$5D,$5D,$5D,$5D
.db $5D,$5D,$5C,$5C,$5C,$5C,$5C,$5C
.db $5C,$5C,$5B,$5B,$5B,$5B,$5B,$5B
.db $5B,$5B,$5B,$5A,$5A,$5A,$5A,$5A
.db $5A,$5A,$5A,$59,$59,$59,$59,$59
.db $59,$59,$58,$58,$58,$58,$58,$58
.db $58,$57,$57,$57,$57,$57,$57,$57
